<?php
/**
 * WoWRoster.net WoWRoster
 *
 * LICENSE: Licensed under the Creative Commons
 *          "Attribution-NonCommercial-ShareAlike 2.5" license
 *
 * @copyright  2002-2007 WoWRoster.net
 * @license    http://creativecommons.org/licenses/by-nc-sa/2.5   Creative Commons "Attribution-NonCommercial-ShareAlike 2.5"
 * @version    SVN: $Id: update_hook.php 317 2007-11-15 03:50:29Z boyo $
 * @link       http://www.wowroster.net
 * @package    phpBBSync
*/
//$A = preg_replace("/%name%/",$Name,$String);
//$this->data['config']['forum_prefix']

if ( !defined('IN_ROSTER') )
{
    exit('Detected invalid access to this file!');
}

/**
 * Addon Update class
 * This MUST be the same name as the addon basename
 */
class phpbbsyncUpdate
{
	var $messages = '';	// Update messages
	var $data = array();	// Addon config data automatically pulled from the addon_config table
	var $files = array();


	/**
	 * Class instantiation
	 * The name of this function MUST be the same name as the class name
	 *
	 * @param array $data	| Addon data
	 * @return recipe
	 */
	function phpbbsyncUpdate($data)
	{
		$this->data = $data;
	}

	/**
	 * Resets addon messages
	 */
	function reset_messages()
	{
		$this->messages = '';
	}


	function update()
	{
		global $roster, $update;

		//Verifiy that phpBBSync is enabled before attempting to procede.
		if ($this->data['config']['main_enable'] == true){
			//Check to see if GroupCalendar sync is enabled and current user is authorized.
			$roster_login = new RosterLogin();
		}
		return true;
	}

	function guild_pre( $data )
	{
		global $roster;

		return true;
	}

	function guild( $data , $memberid )
	{
		global $roster;
// Rather than updating per member, going to update after guild
		return true;
	}

	function guild_post( $data )
	{
		global $roster;
		global $addon;

 		if ($this->data['config']['main_enable'] == true){
 			//Manage groups
 			if ($this->data['config']['guild_groups'] == true){
 				//Create groups if enabled

	 				/* creating all groups that don't exist first*/
	 				$query = "INSERT INTO `{$this->data['config']['forum_prefix']}bbgroups` (`group_type` , `group_name` , `group_description`, `group_moderator`, `group_single_user` ) 
	 					SELECT 1, m.guild_title, '', 0, 0 from {$roster->db->prefix}members m 
						left outer join {$this->data['config']['forum_prefix']}users u on m.name=u.name /*using real name field to store main char name */
						left outer join {$this->data['config']['forum_prefix']}bbgroups g on g.group_name=m.guild_title
						where g.group_name is null and u.name is not null
						group by guild_title";
					$result = $roster->db->query ( $query );
					$this->messages .= "<span class=\"green\">{$roster->locale->act['SuccessCreatingGroup']}</span><br />\n";


 					//Lets create a group for those who are suspended
 					$query = "SELECT * FROM `{$this->data['config']['forum_prefix']}bbgroups` WHERE `group_name` =
 								'{$roster->locale->act['Suspended']}' ";
 					$result = $roster->db->query ( $query );
 					$row = $roster->db->fetch ( $result );
 					if (!$row['group_id']){//It hasnt been created already, so we're going to create it now.
 						$query = "INSERT INTO `{$this->data['config']['forum_prefix']}bbgroups`
 									(`group_type` , `group_name` , `group_description` `group_moderator` ) 
 									VALUES (1, '{$roster->locale->act['Suspended']}', '', '0')";
 						$result = $roster->db->query ( $query );
 						$this->messages .= "<span class=\"green\">{$roster->locale->act['SuccessCreatingGroup']}
 											{$roster->locale->act['Suspended']}</span><br />\n";
 					}else{
 						$this->messages .= "<span class=\"green\">{$roster->locale->act['GroupExists']}
 											{$roster->locale->act['Suspended']}</span><br />\n";
 					}
 					//Now the important bit - moving groups based on guild rank

 					
 					//First remove other memberships
 					$query = "delete from {$this->data['config']['forum_prefix']}bbuser_group where user_id in (select user_id from (SELECT distinct u.user_id from {$roster->db->prefix}memberlog ml
						left outer join {$roster->db->prefix}members m on m.name=ml.name 
						left outer join {$this->data['config']['forum_prefix']}users u on ucase(u.name)=ucase(ml.name)
						left outer join {$this->data['config']['forum_prefix']}bbgroups g on m.guild_title=g.group_name
						left outer join {$this->data['config']['forum_prefix']}bbuser_group ug on ug.user_id = u.user_id 
						where m.name is not null /*makes sure character exists in roster*/
						and u.name is not null /*makes sure user exists in forum*/
						and ug.group_id is not null /*makes sure user belongs to at least one group*/
						and g.group_name is not null /*makes sure the group to move to exists*/
						and u.user_id not in /*makes sure user is not protected*/
						(select ug1.user_id from {$this->data['config']['forum_prefix']}bbuser_group ug1 left outer join {$this->data['config']['forum_prefix']}bbgroups g1 on g1.group_id=ug1.group_id where g1.group_name='Protected')
						) uid )";
					$result = $roster->db->query ( $query );
					//then move to correct membership
					 $query = "insert into {$this->data['config']['forum_prefix']}bbuser_group (group_id, user_id, user_pending)
					 	SELECT distinct g.group_id, u.user_id, 0 from {$roster->db->prefix}memberlog ml
						left outer join {$roster->db->prefix}members m on m.name=ml.name 
						left outer join {$this->data['config']['forum_prefix']}users u on ucase(u.name)=ucase(ml.name)
						left outer join {$this->data['config']['forum_prefix']}bbgroups g on m.guild_title=g.group_name
						left outer join {$this->data['config']['forum_prefix']}bbuser_group ug on ug.user_id = u.user_id 
						where m.name is not null /*makes sure character exists in roster*/
						and u.name is not null /*makes sure user exists in forum*/
						and g.group_name is not null /*makes sure the group to move to exists*/
						and u.user_id not in /*makes sure user is not protected*/
						(select ug1.user_id from {$this->data['config']['forum_prefix']}bbuser_group ug1 left outer join {$this->data['config']['forum_prefix']}bbgroups g1 on g1.group_id=ug1.group_id where g1.group_name='Protected')
						";
					$result = $roster->db->query ( $query );

					
				}
		
 			//Suspend members after leaving the guild. Have to add in something to unsuspend if they rejoin
			if ($this->data['config']['guild_suspend'] == 1){
				//Get the suspended group ID
	/*			$query = "SELECT * FROM `{$this->data['config']['forum_prefix']}membergroups` WHERE `groupName` =
							'{$roster->locale->act['Suspended']}' ";
				$row = $roster->db->fetch ( $roster->db->query ( $query ) );
				$GroupID = $row['ID_GROUP'];

				$query = "SELECT * FROM `{$roster->db->prefix}members` m, `{$this->data['config']['forum_prefix']}members` f
							WHERE m.active = 0 AND f.is_activated = 1 AND m.name = f.realName";
				$result = $roster->db->query ( $query );
				while ($row = $roster->db->fetch ( $result ) ){
					if ($this->protectedGroup($row['realName']) == true){
						$this->messages .= "<span class=\"green\">{$row['realName']} -
											{$roster->locale->act['MemberGroupProtected']}</span><br />\n";
						break;
					}
					$query = "UPDATE `{$this->data['config']['forum_prefix']}members` SET `is_activated` = '0',
								`passwd` = '', `passwordSalt` = '', `emailAddress` = 'SUSPENDED_{$row['emailAddress']}_SUSPENDED',
								`personalText` = '', `signature` = '{$roster->locale->act['NoLongerAMember']}', `avatar` = '',
								`ID_GROUP` = '$GroupID', `additionalGroups` = '' WHERE `realName` = '{$row['name']}' LIMIT 1";
					$roster->db->query( $query );
					//---------------------------------------------No space here \/ because locale file has 's in it.
					$this->messages .= "<span class=\"green\">{$row['realName']}{$roster->locale->act['MemberSuspended']}
									</span><br />\n";

				}
	*/		}//Move members to a different group after leaving.
			elseif($this->data['config']['guild_suspend'] == 2){
				//
				if ($this->data['config']['guild_suspended_group'] != 0){
					// First delete all other memberships
					$query = "delete from {$this->data['config']['forum_prefix']}bbuser_group where user_id in (SELECT distinct u.user_id from {$roster->db->prefix}memberlog ml
						left outer join {$roster->db->prefix}members m on m.name=ml.name 
						left outer join {$this->data['config']['forum_prefix']}users u on ucase(u.name)=ucase(ml.name)
						left outer join {$this->data['config']['forum_prefix']}bbuser_group ug on ug.user_id = u.user_id 
						where m.name is null and u.name is not null and group_id is not null
						and u.user_id not in 
							(select ug1.user_id from {$this->data['config']['forum_prefix']}bbuser_group ug1
							left outer join {$this->data['config']['forum_prefix']}bbgroups g1 on g1.group_id=ug1.group_id
							where g1.group_name=`{$this->data['config']['guild_protected_group']}`)
						)";
					$result = $roster->db->query ( $query );
					//Then add in the suspended membership
					$query = "INSERT INTO {$this->data['config']['forum_prefix']}bbuser_group (group_id, user_id, user_pending)
					SELECT distinct (select group_id from `{$this->data['config']['forum_prefix']}bbgroups` where group_name='{$roster->locale->act['MemberSuspended']}') as group_id, u.user_id, 0 from `{$roster->db->prefix}memberlog` ml
					left outer join `{$roster->db->prefix}members` m on m.name=ml.name 
					left outer join `{$this->data['config']['forum_prefix']}users` u on ucase(u.name)=ucase(ml.name)
					left outer join `{$this->data['config']['forum_prefix']}bbuser_group` ug on ug.user_id = u.user_id 
					where m.name is null and u.name is not null and u.user_id not in 
							(select ug1.user_id from `{$this->data['config']['forum_prefix']}bbuser_group` ug1
							left outer join `{$this->data['config']['forum_prefix']}bbgroups` g1 on g1.group_id=ug1.group_id
							where g1.group_name='{$this->data['config']['guild_protected_group']}')";
					
					$result = $roster->db->query ( $query );
					

				}

			}
		//change location
		if ($this->data['config']['player_update_location'] == true){
			if ($this->data['config']['player_location'] == 'Zone'){
				$query ="update {$this->data['config']['forum_prefix']}users u, {$roster->db->prefix}members m set u.user_from=m.zone where ucase(u.name)=ucase(m.name)";
				$this->messages .= "<span class=\"green\">{$roster->locale->act['LocationUpdated']}</span><br />\n";
			}else{
				$query="update {$this->data['config']['forum_prefix']}users u, {$roster->db->prefix}players p set u.user_from=p.hearth where ucase(u.name)=ucase(p.name) and p.hearth !='';	
			}
		}
		//change sigs and avatars
		if ($this->data['config']['player_enable_signature'] == true){
			//want to use siggen path but can't see how to get this at present. Use path in textbox.
			//Will only change avatar if currently blank.gif. Need to add an option for overwriting.
		}
 		/* 


personal text to guild note
*/
 		}

		return true;
	}

	function char_pre( $data )
	{
		global $roster;

		return true;

	}

	function char( $data , $memberid )
	{
		global $roster;
		/* We don't want to do anything on a character basis - yet
		//The functions here will attempt to update all members of the forum, regardless of what guild they are in.
		//Verifiy that phpBBSync is enabled before attempting to procede.
 		if ($this->data['config']['main_enable'] == true){

 			//Update Hearth or Zone to forum Location (if enabled)
 			if ( ($this->data['config']['player_update_location'] == true)
 					&& ($this->protectedGroup($data['Name']) == false)
 				){
 				//Read the current location setting.
 				$query = "SELECT `location` FROM `{$this->data['config']['forum_prefix']}members` WHERE `realName` =
 							'{$data['Name']}' ";
 				$result = $roster->db->query( $query );

 				$row = $roster->db->fetch ( $result );

 				//Check to make sure the player is a member of the forum before going any further.
 				if ($roster->db->affected_rows() == 1){
	 				if ($this->data['config']['player_location'] == 'Hearth'){
	 					//Location setting is Hearth
		 				//Check if current Location is the same as current Hearth
		 				if(!$data['Hearth']){
		 					$this->messages .= "<span class=\"yellow\">{$roster->locale->act['LocationNotSpecified']}
		 										</span><br />\n";
		 				}elseif ($row['location'] == $data['Hearth']){
		 					$this->messages .= "<span class=\"green\">{$roster->locale->act['LocationIsCurrent']}
		 										</span><br />\n";
		 				}else{
		 					$query = "UPDATE `{$this->data['config']['forum_prefix']}members` SET `location` =
		 								'{$data['Hearth']}'	WHERE `realName` = '{$data['Name']}' LIMIT 1 ";
		 					$result = $roster->db->query ( $query );
		 					$ResultRows = $roster->db->affected_rows();
		 					if ($ResultRows == 1){
		 						$this->messages .= "<span class=\"green\">{$roster->locale->act['LocationUpdatedFrom']}
		 											{$row['location']} {$roster->locale->act['to']} {$data['Hearth']}
		 											</span><br />\n";
		 					}else{
		 						$this->messages .= "<span class=\"red\">{$roster->locale->act['LocationNotUpdated']}
		 											</span><br />\n";
		 					}

		 				}
	 				}elseif($this->data['config']['player_location'] == 'Zone'){
	 					//Location setting is Zone
		 				//Check if current Location is the same as current Hearth
		 				if(!$data['Zone']){
		 					$this->messages .= "<span class=\"yellow\">{$roster->locale->act['LocationNotSpecified']}
		 										</span><br />\n";
		 				}elseif ($row['location'] == $data['Zone']){
		 					$this->messages .= "<span class=\"green\">{$roster->locale->act['LocationIsCurrent']}
		 										</span><br />\n";
		 				}else{
		 					$query = "UPDATE `{$this->data['config']['forum_prefix']}members` SET `location` =
		 								'{$data['Zone']}' WHERE `realName` = '{$data['Name']}' LIMIT 1 ";
		 					$result = $roster->db->query ( $query );
		 					$ResultRows = $roster->db->affected_rows();
		 					if ($ResultRows == 1){
		 						$this->messages .= "<span class=\"green\">{$roster->locale->act['LocationUpdatedFrom']}
		 											{$row['location']} {$roster->locale->act['to']} {$data['Zone']}
		 											</span><br />\n";
		 					}else{
		 						$this->messages .= "<span class=\"red\">{$roster->locale->act['LocationNotUpdated']}
		 											</span><br />\n";
		 					}

		 				}
 					}
 				}else{
 					$this->messages .= "<span class=\"red\">{$roster->locale->act['PlayerNotInForum']}</span><br />\n";
 				}

 			}//End of Player Update Location
 		}
*/
 		return true;
	}

	function char_post( $data )
	{
		global $roster;

		return true;
	}

}